/* byte2bit.c

convert a  1-byte-per-pixel mask into a 1-bit-to-pixel mask
assumes the total number of bytes is evenly divisible by 8
whf smith, 19 aug 2002

*/

#include <stdio.h>

unsigned char maskset[8] = { 128, 64, 32, 16, 8, 4, 2, 1};

main (int argc, char **argv) {

	unsigned char input[8], output;
	int	i;
	int	lat,lon,ij,nwords;

        nwords=0;
	
	if (argc > 1) {
		fprintf (stderr, "usage:  byte2bit < bytemask.dat > bitmask.dat\n");
		fprintf (stderr, "\t assumes input size in bytes is divisible by 8;\n");
		fprintf (stderr, "\t input has one binary state per input byte;\n");
		fprintf (stderr, "\t 0 input yields 0 output; non-zero input yields 1 output.\n");
		fprintf (stderr, "\t the sense of 0 and 1 can be reversed by changing code inside.\n");
		exit (-1);
	}
	
	while ( (fread ( (void *)input, (size_t)1, (size_t)8, stdin ) ) == (size_t)8 ) {
		output = 0;
		for (i = 0; i < 8; i++) {
		if (input[i] != 0) output = (output | maskset[i]);
		}
	  	fwrite ( (void *)&output, (size_t)1, (size_t)1, stdout );
		nwords=nwords+1;
	}
	exit (0);
}

